<!DOCTYPE html>
<html lang="en">
<head>
  <title>task 41.10 Filter Users</title>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1">
  <link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/css/bootstrap.min.css">
  <script src="https://ajax.googleapis.com/ajax/libs/jquery/3.5.1/jquery.min.js"></script>
  <script src="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/js/bootstrap.min.js"></script>

  <!-- Import Datatable sau jquery -->
  <!-- Import them style bootstrap cho datatable -->
  <link rel="stylesheet" href="https://cdn.datatables.net/1.10.24/css/dataTables.bootstrap4.min.css">
  <script src="https://cdn.datatables.net/1.10.24/js/jquery.dataTables.min.js"></script>
  <script src="https://cdn.datatables.net/1.10.24/js/dataTables.bootstrap4.min.js"></script>

<script>
  "use strict";
  $(document).ready(function() {
    /*** REGION 1 - Global variables - Vùng khai báo biến, hằng số, tham số TOÀN CỤC */
    const gCONTENT_TYPE = 'application/json;charset=UTF-8';
    const gCOLUMN_1 = 0;
    const gCOLUMN_2 = 1;
    const gCOLUMN_3 = 2;
    const gCOLUMN_4 = 3;
    const gCOLUMN_5 = 4 ;
    const gCOLUMN_6 = 5;
    const gCOLUMN_7 = 6;
    const gCOLUMN_8 = 7;
    const gCOLUMN_9 = 8;

    const gCOL_NAME= ["orderCode","kichCo" ,"loaiPizza","idLoaiNuocUong", "thanhTien","hoTen" ,"soDienThoai" , "trangThai" , "action"]
    
    var gOderList = []

    var gOderCode = "";
    var gId = "";
    // định nghĩa table  - chưa có data
    var gOderTable = $("#user-table").DataTable( {
      // Khai báo các cột của datatable
      "columns" : [
          { "data" : gCOL_NAME[gCOLUMN_1] },
          { "data" :  gCOL_NAME[gCOLUMN_2] },
          { "data" :  gCOL_NAME[gCOLUMN_3] },
          { "data" :  gCOL_NAME[gCOLUMN_4] },
          { "data" :  gCOL_NAME[gCOLUMN_5] },
          { "data" :  gCOL_NAME[gCOLUMN_6] },
          { "data" :  gCOL_NAME[gCOLUMN_7] },
          { "data" :  gCOL_NAME[gCOLUMN_8] },
          { "data" :  gCOL_NAME[gCOLUMN_9] }
      ],
      // Ghi đè nội dung của cột action, chuyển thành button chi tiết
      "columnDefs": [ 
      {
          "targets": gCOLUMN_9,
          "defaultContent": "<button class='info-user btn btn-info'>Chi tiết</button>"
      }]
    });
    
    /*** REGION 2 - Vùng gán / thực thi hàm xử lý sự kiện cho các elements */
    onPageLoading();

    // gán click event handler cho button chi tiet
    $("#user-table").on("click", ".info-user", function() {
      onButtonChiTietClick(this); // this là button được ấn
    });

    $("#btn-filter").on("click", function() {
      onFilterData();
    })

    $("#btn-confirm").on("click", function () {
      onBtnConfirmClick();
    })

    $("#btn-cancel").on("click", function () {
      onBtnCancelClick();
    })

    /*** REGION 3 - Event handlers - Vùng khai báo các hàm xử lý sự kiện */  
    // ham loc du lieu
    function onFilterData() {
      // chuan bi du lieu dau vao
      var vFilterObj = {
        trangThai: "",
        loaiPizza: ""
      }

      getDataToFilter(vFilterObj);
      // xu li du kieu dau vao
      var   vFilerData = filterData(vFilterObj);
      // xu ly du lieu dau ra

      loadDataToTable(vFilerData);
    }
    // infoFunction sẽ là function các nút cùng gọi
    function onButtonChiTietClick(paramChiTietButton) {
      //Xác định thẻ tr là cha của nút được chọn
      var vRowSelected = $(paramChiTietButton).parents('tr');
      //Lấy datatable row
      var vDatatableRow = gOderTable.row(vRowSelected); 
      //Lấy data của dòng 
      var vOderData = vDatatableRow.data();
      console.log(vOderData);
      gOderCode= vOderData.orderCode;
      gId= vOderData.id;
      $.ajax({
        url:  "http://203.171.20.210:8080/devcamp-pizza365/orders/" + gOderCode, 
        type: "GET",
        dataType: 'json',
        success: function(responseObject){
          gOderList = responseObject;
          //debugger;
          loadDataToModal(responseObject);
        },
        error: function(error){
          console.assert(error.responseText);
        }
      });
    }
      

    

    // hàm chạy khi trang được load
    function onPageLoading() {
      // lấy data từ server
      getAllOrder();
    }

    function getAllOrder() {
      $.ajax({
        url:  "http://203.171.20.210:8080/devcamp-pizza365/orders",
        type: "GET",
        dataType: 'json',
        success: function(responseObject){
          gOderList = responseObject;
          //debugger;
          loadDataToTable(responseObject);
        },
        error: function(error){
          console.assert(error.responseText);
        }
      });
	}

    function onBtnConfirmClick() {
      var vTrangThaiObj = {
        trangThai: "confirmed",
      }
      console.log(gId);
      $.ajax({
        url:  "http://203.171.20.210:8080/devcamp-pizza365/orders/" + gId,
        type: "PUT",
        data: JSON.stringify(vTrangThaiObj),
        contentType: gCONTENT_TYPE,
        dataType: 'json',
        success: function(responseObject){
          gOderList = responseObject;
          //debugger;
          handleConfirmOrderSuccess();
        },
        error: function(error){
          console.assert(error.responseText);
        }
      });

    }

    function onBtnCancelClick() {
      var vTrangThaiObj = {
        trangThai: "cancel",
      }
      console.log(gId);
      $.ajax({
        url:  "http://203.171.20.210:8080/devcamp-pizza365/orders/" + gId,
        type: "PUT",
        data: JSON.stringify(vTrangThaiObj),
        contentType: gCONTENT_TYPE,
        dataType: 'json',
        success: function(responseObject){
          gOderList = responseObject;
          //debugger;
          handleConfirmOrderSuccess();
        },
        error: function(error){
          console.assert(error.responseText);
        }
      });

    }

   
    /*** REGION 4 - Common funtions - Vùng khai báo hàm dùng chung trong toàn bộ chương trình */
   function getDataToFilter(paramOder) {
    paramOder.trangThai = $("#sel-trangthai").val();
    paramOder.loaiPizza = $("#sel-pizza").val();
    console.log(paramOder);
   }


   //ham tien hanh loc du lieu
   function filterData(paramFilterObj){
    var vResult = [];

    vResult = gOderList.filter((paramOder) => {


      return (paramFilterObj.trangThai == "0" ||  paramOder.trangThai.toLowerCase().includes(paramFilterObj.trangThai.toLowerCase())) && 
      (paramFilterObj.loaiPizza == "0" || paramOder.loaiPizza.toLowerCase().includes(paramFilterObj.loaiPizza.toLowerCase()))
    })
    return vResult
   }
   
    // load data to table
    function loadDataToTable(paramResponseObject) {
      //Xóa toàn bộ dữ liệu đang có của bảng
      gOderTable.clear();
      //Cập nhật data cho bảng 
      gOderTable.rows.add(paramResponseObject);
      //Cập nhật lại giao diện hiển thị bảng
      gOderTable.draw();
    }

    function loadDataToModal(paramData) {

      $("#input-orderCode").val(paramData.orderCode);
      $("#input-kichCo").val(paramData.kichCo);
      $("#input-duongKinh").val(paramData.duongKinh);
      $("#input-suon").val(paramData.suon);
      $("#input-salad").val(paramData.salad);
      $("#input-loaiPizza").val(paramData.loaiPizza);
      $("#input-idVourcher").val(paramData.idVourcher);
      $("#input-thanhTien").val(paramData.thanhTien);
      $("#input-giamGia").val(paramData.giamGia);
      $("#sel-idLoaiNuocUong").val(paramData.idLoaiNuocUong);
      $("#input-soLuongNuoc").val(paramData.soLuongNuoc);
      $("#input-hoTen").val(paramData.hoTen);
      $("#input-email").val(paramData.email);
      $("#input-soDienThoai").val(paramData.soDienThoai);
      $("#input-diaChi").val(paramData.diaChi);
      $("#input-loiNhan").val(paramData.loiNhan);
      $("#input-ngayTao").val(paramData.ngayTao);
      $("#input-ngayCapNhat").val(paramData.ngayCapNhat);
      $("#oderdetail-modal").modal("show");

    }

    function handleConfirmOrderSuccess() {
		alert('Sửa order thành công!');
		getAllOrder();
		$("#oderdetail-modal").modal('hide');
	}
  });
</script>
</head>
<body>
<div class="container">
  <h2 style="text-align: center;">DANH SÁCH ĐƠN HÀNG</h2>

  <div class="row jumbotron">
    <div class="col-2">
      <label class="form-label">Trạng thái Order</label>
    </div>
    <div class="col-3">
      <select class="form-control" id="sel-trangthai">
        <option value="0">All</option>
        <option value="confirmed">Confirmed</option>
        <option value="open">Open</option>
        <option value="cancel">Cancel</option>
      </select>
    </div>
    <div class="col-2">
      <label class="form-label">Loại pizza</label>
    </div>
    <div class="col-3">
      <select class="form-control" id="sel-pizza">
        <option value="0">All</option>
        <option value="hawaii">Hawaii</option>
        <option value="bacon">Bacon</option>
        <option value="seafood">Seafood</option>
      </select>
    </div>
    <div class="col-2">
      <button class="btn btn-success" id="btn-filter">Lọc dữ liệu</button>
    </div>
  </div>
  
  <table class="table table-bordered table-striped table-hover" id="user-table">
    <thead>
      <tr>
        <th>Order Code</th>
        <th>kich Cỡ</th>
        <th>loaị Pizza</th>
        <th>Nước uống</th>
        <th>Thành tiền</th>
        <th>Họ và tên</th>
        <th>Số điện thoại</th>
        <th>Trạng thái</th>
        <th>Action</th>
      </tr>
  </table>
</div>
<div>
  <div id="oderdetail-modal" class="modal fade" tabindex="-1">
    <div class="modal-dialog">
      <div class="modal-content">
        <div class="modal-header">
          <h5 class="modal-title" id="h5-modal-title">Oder detail</h5>
          <button class="close" data-dismiss="modal">&times;</button>
        </div>
        <div class="modal-body">
          <form>
            <div class="row form-group">
              <div class="col-sm-4">
                <label for="input">Order Code</label>
              </div>
              <div class="col-sm-8">
                <input
                  type="text"
                  id="input-orderCode"
                  name="orderCode"
                  placeholder="orderCode"
                  class="form-control"
                />
              </div>
            </div>
            <div class="row form-group">
              <div class="col-sm-4">
                <label for="input">Pizza size</label>
              </div>
              <div class="col-sm-8">
                <input
                  type="text"
                  id="input-kichCo"
                  name="kichCo"
                  placeholder="kichCo"
                  class="form-control"
                />
              </div>
            </div>
            <div class="row form-group">
              <div class="col-sm-4">
                <label for="input">Đường kính</label>
              </div>
              <div class="col-sm-8">
                <input
                  type="text"
                  id="input-duongKinh"
                  name="duongKinh"
                  placeholder="duongKinh"
                  class="form-control"
                />
              </div>
            </div>
            <div class="row form-group">
              <div class="col-sm-4">
                <label for="input">Sườn</label>
              </div>
              <div class="col-sm-8">
                <input
                  type="text"
                  id="input-suon"
                  name="suon"
                  placeholder="suon"
                  class="form-control"
                />
              </div>
            </div>
            <div class="row form-group">
              <div class="col-sm-4">
                <label for="input">Salad</label>
              </div>
              <div class="col-sm-8">
                <input
                  type="text"
                  id="input-salad"
                  name="salad"
                  placeholder="salad"
                  class="form-control"
                />
              </div>
            </div>
            <div class="row form-group">
              <div class="col-sm-4">
                <label for="input">Pizza Type</label>
              </div>
              <div class="col-sm-8">
                <input
                  type="text"
                  id="input-loaiPizza"
                  name="loaiPizza"
                  placeholder="loaiPizza"
                  class="form-control"
                />
              </div>
            </div>
            <div class="row form-group">
              <div class="col-sm-4">
                <label for="input">ID voucher</label>
              </div>
              <div class="col-sm-8">
                <input
                  type="text"
                  id="input-idVourcher"
                  name="idVourcher"
                  placeholder="idVourcher"
                  class="form-control"
                />
              </div>
            </div>
            <div class="row form-group">
              <div class="col-sm-4">
                <label for="input">Thành tiền</label>
              </div>
              <div class="col-sm-8">
                <input
                  type="text"
                  id="input-thanhTien"
                  name="thanhTien"
                  placeholder="thanhTien"
                  class="form-control"
                />
              </div>
            </div>
            <div class="row form-group">
              <div class="col-sm-4">
                <label for="input">Giamr giá</label>
              </div>
              <div class="col-sm-8">
                <input
                  type="text"
                  id="input-giamGia"
                  name="giamGia"
                  placeholder="giamGia"
                  class="form-control"
                />
              </div>
            </div>
            <div class="row form-group">
              <div class="col-sm-4">
                <label for="idLoaiNuocUong">Loại đồ uống</label>
              </div>
              <div class="col-sm-8">
                <select class="form-control" id="sel-idLoaiNuocUong">
                  <option value="Chọn đồ uống">Chọn đồ uống</option>
                  <option value="COCA">CoCa</option>
                  <option value="PEPSI">PEPSI</option>
                  <option value="TRATAC">TRATAC</option>
                </select>
              </div>
            </div>
            <div class="row form-group">
              <div class="col-sm-4">
                <label for="input">Số lượng nước uống</label>
              </div>
              <div class="col-sm-8">
                <input
                  type="text"
                  id="input-soLuongNuoc"
                  name="soLuongNuoc"
                  placeholder="soLuongNuoc"
                  class="form-control"
                />
              </div>
            </div>
            <div class="row form-group">
              <div class="col-sm-4">
                <label for="input">Họ và tên</label>
              </div>
              <div class="col-sm-8">
                <input
                  type="text"
                  id="input-hoTen"
                  name="hoTen"
                  placeholder="hoTen"
                  class="form-control"
                />
              </div>
            </div>
            <div class="row form-group">
              <div class="col-sm-4">
                <label for="input">Email</label>
              </div>
              <div class="col-sm-8">
                <input
                  type="text"
                  id="input-email"
                  name="email"
                  placeholder="email"
                  class="form-control"
                />
              </div>
            </div>
            <div class="row form-group">
              <div class="col-sm-4">
                <label for="input">Số điện thoại</label>
              </div>
              <div class="col-sm-8">
                <input
                  type="text"
                  id="input-soDienThoai"
                  name="soDienThoai"
                  placeholder="soDienThoai"
                  class="form-control"
                />
              </div>
            </div>
            <div class="row form-group">
              <div class="col-sm-4">
                <label for="input">Địa chỉ</label>
              </div>
              <div class="col-sm-8">
                <input
                  type="text"
                  id="input-diaChi"
                  name="diaChi"
                  placeholder="diaChi"
                  class="form-control"
                />
              </div>
            </div>
            <div class="row form-group">
              <div class="col-sm-4">
                <label for="input">Lời nhắn</label>
              </div>
              <div class="col-sm-8">
                <input
                  type="text"
                  id="input-loiNhan"
                  name="loiNhan"
                  placeholder="loiNhan"
                  class="form-control"
                />
              </div>
            </div>
            <div class="row form-group">
              <div class="col-sm-4">
                <label for="input">Ngày order</label>
              </div>
              <div class="col-sm-8">
                <input
                  type="text"
                  id="input-ngayTao"
                  name="ngayTao"
                  placeholder="ngayTao"
                  class="form-control"
                />
              </div>
            </div>
            <div class="row form-group">
              <div class="col-sm-4">
                <label for="input">Ngày chỉnh sửa</label>
              </div>
              <div class="col-sm-8">
                <input
                  type="text"
                  id="input-ngayCapNhat"
                  name="ngayCapNhat"
                  placeholder="ngayCapNhat"
                  class="form-control"
                />
              </div>
            </div>
          </form>
        </div>
        <div class="modal-footer">
          <div class="row" style="width: 100%;">
            <div class="col-6">
              <button class="btn btn-warning" style="width: 100%;" id="btn-confirm">
                Confirm
              </button>
            </div>
            <div class="col-6">
              <button
              class="btn btn-danger"
              style="width: 100%;"
              id="btn-cancel"

            >
              Cancel
            </button>
            </div>
          </div>
        </div>
        <div class="modal-footer">

          <div class="row">
            <button
            class="btn btn-dark"
            id="btn-close"
            data-dismiss="modal"
          >
            close
          </button>
          </div>



        </div>
      </div>
    </div>
  </div>
</div>
</body>
</html>